#!/usr/bin/env python
# -*- coding: utf-8 -*-
#todo: clean this mess up !
import wx
class ConfDialog(wx.Dialog):
    def __init__(
            self, parent, ID, options, title, size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE         
            ):
        
        wx.Dialog.__init__(self,parent,ID,title,pos,size,style)
        self.options=options

        threadList = ['1', '2', '3', '4', '5', '6','7','8']
        siteList = ['youporn', 'pussyplace']
        pageList =['All','1','2', '3', '4', '5', '6','7','8']
        
        content = wx.BoxSizer(wx.VERTICAL)
        
        siteContent = wx.BoxSizer(wx.HORIZONTAL)
        siteTxt=wx.StaticText(self, -1, "Site:", (15, 50), (75, -1))
        self.siteChoice = wx.Choice(self, -1, (100, 50), choices = siteList)
        site = self.options.maxpages
        i=0
        found=False
        for s in siteList:
            if s==site:
                self.siteChoice.Select(i)
                found=True
            i=i+1
        if found==False:
            self.siteChoice.Select(0)
            
        siteContent.Add(siteTxt, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        siteContent.Add(self.siteChoice, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        threadContent = wx.BoxSizer(wx.HORIZONTAL)
        threadTxt=wx.StaticText(self, -1, "Threads:", (15, 50), (75, -1))
        self.threadChoice = wx.Choice(self, -1, (100, 50), choices = threadList)
        threads = self.options.numberOfThreads-1
        if threads>len(threadList):
            threads=len(threadList)-1
        self.threadChoice.Select(threads)
        threadContent.Add(threadTxt, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        threadContent.Add(self.threadChoice, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        pagesContent = wx.BoxSizer(wx.HORIZONTAL)
        pagesTxt=wx.StaticText(self, -1, "Pages:", (15, 50), (75, -1))
        self.pagesChoice = wx.Choice(self, -1, (100, 50), choices = pageList)
        pages = self.options.maxpages-1
        if pages<0:
            self.pagesChoice.Select(0)
        else:
            if pages>len(pageList):
                pages=len(pageList)-1
            self.pagesChoice.Select(pages)
                
            
        pagesContent.Add(pagesTxt, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        pagesContent.Add(self.pagesChoice, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        optionsContent = wx.BoxSizer(wx.HORIZONTAL)
        self.overwriteCb = wx.CheckBox(self,-1,'overwrite',(100,50),style=wx.ALIGN_RIGHT)
        if self.options.overwrite:
            self.overwriteCb.SetValue(True)
        self.verboseCb = wx.CheckBox(self,-1,'verbose',(100,50),style=wx.ALIGN_RIGHT)
        if self.options.verbose:
            self.verboseCb.SetValue(True)
        optionsContent.Add(self.overwriteCb, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        optionsContent.Add(self.verboseCb, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        content.Add(siteContent, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        content.Add(threadContent, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        content.Add(pagesContent, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        content.Add(optionsContent, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        btnsizer = wx.StdDialogButtonSizer()
        btn = wx.Button(self, wx.ID_OK)
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        content.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(content)
        content.Fit(self)
       

import loadyouporn, loadpussyplace
import sys, Queue
from optparse import OptionParser

parser=OptionParser()

    
def initOptions():
    parser.add_option("-d", dest="destination", default=None, help="destination directory for downloaded files")
    parser.add_option("-s", dest="site", default=None, help="specify a supported site to download from (eg. youporn)")
    parser.add_option("-n", dest="numberOfThreads",default=5, type="int", help="number of simultaneous downloads")
    parser.add_option("-m", dest="maxpages", default=-1, type="int", help="maximum number of initial pages to scan (-1 = unlimited)")
    parser.add_option("-p", dest="preferredType", default=None, help="preferred type if several exist for the SAME file (like wmv, flv)")
    parser.add_option("-c", dest="complete", default=False, action="store_true", help="download the whole site(s) (instead of all files till the first allready existing one is found)")
    parser.add_option("-o", dest="overwrite", default=False,action="store_true", help="overwrite existing files (includes -c)")
    parser.add_option("-v", dest="verbose", action="store_false",  default=True,help="don't print status messages to stdout")
    parser.add_option("-g", dest="gui", action="store_false",  default=True,help="start a config dialog")
    
    
def initFetchers(options):
    fetchers=[]
    if options.site==None: #default only youporn for now
        fetchers.append(loadyouporn.LoadYouPorn(options))
    elif options.site=="youporn":
        fetchers.append(loadyouporn.LoadYouPorn(options))
    elif options.site=="pussyplace":
        fetchers.append(loadpussyplace.PussyPlace(options))
    
    return fetchers

def startConfDialog(parent,options):
    dlg = ConfDialog(parent, -1, options,"PPython 0.3", size=(350, 200))
    dlg.CenterOnScreen()

    # this does not return until the dialog is closed.
    val = dlg.ShowModal()
    dlg.Destroy()
    if val == wx.ID_OK:
        options.verbose=dlg.verboseCb.GetValue()
        options.overwrite=dlg.overwriteCb.GetValue()
        options.site=dlg.siteChoice.GetString(dlg.siteChoice.GetSelection())
        options.numberOfThreads=int(dlg.threadChoice.GetString(dlg.threadChoice.GetSelection()))
        if dlg.pagesChoice.GetSelection()==0:
            options.maxpages=-1
        else:
            options.maxpages=int(dlg.pagesChoice.GetString(dlg.pagesChoice.GetSelection()))
        fetchers=initFetchers(options)
        for fetcher in fetchers:
            fetcher.start()
            
        return True
          
def main():
    initOptions()
    (options, args) = parser.parse_args()
    ok=False
    app=None
    if options.gui:
        #import wx
        app = wx.App(False)
        frame = wx.Frame(None, -1, ' ')
        startConfDialog(frame,options)
    else:
        fetchers=initFetchers(options)
        for fetcher in fetchers:
            fetcher.start()
    
if __name__=="__main__":
    main()


