#!/usr/bin/env python
# -*- coding: utf-8 -*-

import urllib, urllib2, re, os
from threadpool import * 

class LoadYouPorn:
    def __init__(self, options):
        self.allFiles={}
        self.preference=options.preferredType
        self.overwrite=options.overwrite
        self.complete=options.complete
        self.maxpages=options.maxpages
        self.numThreads=options.numberOfThreads
        self.rootDir=options.destination
        self.verbose=options.verbose
        
    def start(self):
        baseURL="http://youporn.com"
        linkpattern="/watch/[0-9]*"
        try:
            if self.verbose:
                print "Accessing mainpage: "+baseURL
            html = self.fetchpage(baseURL)
        except:
                print "Problems fetching page ! Site down ? Will abort"
                return
        maxpages=int(self.findLastPage(html))
        if self.maxpages==-1:
            self.maxpages=int(self.findLastPage(html))+1
        else:
            if maxpages>=self.maxpages:
                self.maxpages=self.maxpages+1 
            else:
                self.maxpages=maxpages+1
        if self.verbose:
            print "Pages to check : "+ str(self.maxpages)
        # now start the threadpool
        # we create a pool of numThread worker threads
        if self.verbose:
            print "Initializing ThreadPool of size:",self.numThreads
        main = ThreadPool(self.numThreads)
        
        #now the loop for each page
        for page in range(1, self.maxpages):
            links=[]
            allfiles=[]
            if self.verbose:
                print "fetching: "+baseURL+'/?page='+str(page)
            try:
                html=self.fetchpage(baseURL+'/?page='+str(page))
                links=self.searchlinks(html,linkpattern,baseURL)
            except:
                print "Problems fetching page ! Site down ?"
            if self.verbose:
                print "video pages to check for page : ",str(len(links))
            for page in set(links):
                newfiles=[]
                if self.verbose:
                    print "looking for files in: " + page  
                try:
                    html=self.fetchpage(page)
                except:
                    print "Problems finding files ! Site down ?"
                else:
                    newfiles=self.searchfiles(html)
                if newfiles == None:
                    continue 
                allfiles.extend(newfiles)
            print "Files to download:",len(allfiles)
              
            #Now start the threads for
            # assemble the arguments for each job to a list...
            data = allfiles
            # ... and build a WorkRequest object for each item in data
            requests = makeRequests(self.downloadFile, data, self.print_result, self.handle_exception)
            # then we put the work requests in the queue...
            [main.putRequest(req) for req in requests]
            # ...and wait for the results to arrive in the result queue
            main.wait()
  
    def downloadFile(self,url): 
        request = urllib2.Request(url)
        try:
            handle = urllib2.urlopen(request)
        except IOError: # 400+ error
            print "There seems to be a problem with ", url
            return url
        except ValueError:      # url error
            print "Bad format:", url
            return url
        else:
            filename=self.getFileName(url)
            tempfilename=filename+'.temp'
            print "Download started:", filename
            urllib.urlretrieve(url, tempfilename) 
            os.rename(tempfilename,filename)
            print "Download completed:", filename
            return "file downloaded"
                
    def fetchpage(self,url):
        pagefile= urllib.urlopen(url) #enter proxy here if wished
        return pagefile.read()

    def findLastPage(self,html):
        linkPattern="page\=[0-9]*"
        p = re.compile(linkPattern)
        m= p.findall(html)
        #print m
        m.pop() # last item = next
        lastPage=m.pop()
        lastPage=lastPage[lastPage.rfind('=')+1:] #get rid of the 'page='
        if self.verbose:
            print "Pages range till:",lastPage
        return lastPage
          
    def searchlinks(self,html, pattern,baseURL=None):
        ''' used to search for filepages 
        within a gallerypage in youporn
        '''
        p = re.compile(pattern)
        m= p.findall(html)
        #print set(m)
        links=[]
        for page in set(m):
            if baseURL!=None:
                page=baseURL+page
            links.append(page)
        return links  

    def searchfiles(self,html):
        ''' used to search for files 
        within a filepage in youporn
        '''
        allFiles=[]
        flvPattern="http://[\w0-9]*.youporn.com/download/[0-9]*/flv/[\w_]*.flv"
        wmvPattern="http://[\w0-9]*.youporn.com/download/[0-9]*/pc/[\w_]*.wmv"
        p = re.compile(flvPattern)
        p2 = re.compile(wmvPattern)
        m=None
        if self.preference=="wmv":
            if self.verbose:
                print "Using preferenced type wmv"
            m= p2.search(html)
        if m==None or self.preference!="wmv":    
            #if self.verbose:
             #   print "no wmv found or different file type selected"
            m=p.search(html)
            if m==None:
                return
        url = m.group()
        filename=self.getFileName(url)#url[url.rfind("/")+1:]
        if self.verbose:
            print "found file:",filename,"at:",url
        if not os.path.exists(filename) or self.overwrite==True:
            allFiles.append(url)
        else:
            if self.verbose:
                print "file already exists:",filename
        return allFiles

    def getFileName(self,url):
        return url[url.rfind("/")+1:]

    ###########Thread methods
    # this will be called each time a result is available
    def print_result(self,request, result):
        print "**Result: %s from request #%s" % (result, request.requestID)

    # this will be called when an exception occurs within a thread
    def handle_exception(self,request, exc_info):
        print "Exception occured in request #%s: %s" % (request.requestID, exc_info[1])
    

    
